c ==========================================================================
c
c           MPS input formatum feldolgozasa  character*8 tombok nelkul
c         --------------------------------------------------------------
c                       egyszeru  hashing technikaval
c
c
c                       Comment ( '*' ) figyelessel
c C sor,oszlop,ranges,rhs es bounds nevek elso karaktere nem lehet '*' (mert
c   ez esetben megjegyzesnek szamit), egyebkent mashol szerepelhet bennuk.
c     Oszlop es sornevkent az ures string ('        ') nem szerepelhet,
c  RHS,BOUNDS,RANGES nevkent pedig csak ugy, ha ez az egyetlen ilyen nev.
c     Az oszlopnevek rendezve vannak, binaris kereses a BOUNDS-ban.
c  Az oszlopnevek ismetlodesenek es a numerikus formatum helyessegenek a
c                          vizsgalata beepitve.
c         Az MPS file-ban levo nulla elemek nem kerulnek tarolasra !
c
c Utolso modositas : 1994 januar 31.
c ==========================================================================
c
      subroutine mpsinput(filnam,fin,objname,rhsname,bouname,ranname,
     x m,n,nz,addobj,minmax,rowidx,nonzeros,rownam,colnam,rhs,range,
     x lbound,ubound,rowtyp,index1,index2,colpnt,big,maxm,maxn,maxnz,
     x obj,colind,rhdr,chdr,iok,tzer,bigbou,inslck,nn,sfile)
c
      integer*4    m,n,nz,maxm,maxn,maxnz,rowidx(maxnz),rowtyp(maxm),
     x             index1(maxm),colpnt(maxn+1),colind(maxn),
     x             index2(maxn),fin,minmax,rhdr(maxm),chdr(maxn),iok,
     x             inslck,nn,sfile
      real*8       nonzeros(maxnz),rhs(maxm),range(maxm),lbound(maxn),
     x             ubound(maxn),obj(maxn),big,addobj,tzer,bigbou
      character*8  objname,rhsname,bouname,ranname
      integer*4    rownam(2*maxm),colnam(2*maxn)
c
      character*8  name0,name1,name2,c1,oldname
      character*3  sense
      character*4  sen4
      integer*4    i,pnt,ix,in,lcol,icol,hsval,ni,mi,freen
      real*8       val1,val2
      character*40 filnam
      character*99 buff
      integer*4 wignore,w1,w2,w3,w4,w5,w6,w7,w8,w9,w0
c
c --------------------------------------------------------------------------
c
    2 format(1x,'WRONG BOUNDS FOR THE VARIABLE ',a8)
    3 format(1x,'WRONG FILENAME : ',a40)
    5 format(1x,'Column hashing       : ',I8,'   Row    hashing :',i8)
    9 format(1x,'RHS       name       : ',A8,'   RHS    records :',i8)
   10 format(1x,'RANGES    name       : ',A8,'   RANGES records :',i8)
   11 format(1x,'BOUNDS    name       : ',A8,'   BOUNDS records :',i8)
   12 format(1x,a22,i8)
   13 format(1x,a22,i8,'    column name    : ',a8)
c
      w1=0
      w2=0
      w3=0
      w4=0
      w5=0
      w6=0
      w7=0
      w8=0
      w9=0
      w0=0
      wignore=5
      freen=0
      iok=0
      open(fin,file=filnam,status='OLD',err=15)
      goto 20
  15  write(buff,3)filnam
      call mprnt(buff)
      stop
  20  do 1 i=1,maxm
        index1(i)=0
        rhdr(i)=0
   1  continue
      do 4 i=1,maxn
        index2(i)=0
        chdr(i)=0
   4  continue
      m=0
      n=0
      mi=0
      ni=0
      addobj=0.0d+0
      write(buff,'(1X)')
      call mprnt(buff)
      pnt=1
      call freadnam(fin)
      call fread(fin,sense,name0,name1,val1,name2,val2,w8,wignore)
      if(sense.ne.'ROW')then
        write(buff,'(1x,a)')'FATAL : ROWS NOT FOUND'
        call mprnt(buff)
        stop
      endif
c
c default value for the objective function
c
      do 22 i=1,maxn
        obj(i)=0.0d+0
  22  continue
c
c rows section
c
      ix=0
  25  call fread(fin,sense,name0,name1,val1,name2,val2,w8,wignore)
      if(sense.ne.'COL')then
        if(((sense.eq.' N ').OR.(SENSE.EQ.'  N')).and.(ix.eq.0))then
          if(objname.eq.'        ')objname=name0
          if(objname.eq.name0)then
            ix=1
            goto 25
          endif
        endif
        m=m+1
        colind(m)=0
        if(m.gt.maxm)then
          write(buff,'(1x,a,i8)')'To many rows. Current maximum :',maxm
          call mprnt(buff)
          iok=1
          goto 925
        endif
        call ctob(rownam(m),rownam(m+maxm),name0,maxm,hsval)
        if(rhdr(hsval).eq.0)mi=mi+1
        index1(m)=rhdr(hsval)
        rhdr(hsval)=m
        if(sense.eq.' EQ')sense=' E '
        if((sense.eq.' N ').OR.(SENSE.EQ.'  N'))then
          rowtyp(m)=0
        else if ((sense.eq.' E ').OR.(SENSE.EQ.'  E'))then
          rowtyp(m)=1
        else if ((sense.eq.' G ').OR.(SENSE.EQ.'  G'))then
          rowtyp(m)=2
        else if ((sense.eq.' L ').OR.(SENSE.EQ.'  L'))then
          rowtyp(m)=3
        else
          w1=w1+1
          if(w1.le.wignore)then
            write(buff,'(1x,a,a,a)')'Wrong rowtype : ',sense,
     x      '  Replaced with   G'
            call mprnt(buff)
          endif
          rowtyp(m)=2
        endif
        goto 25
      endif
      if(ix.le.0)then
        write(buff,'(1x,a)')'No objective function !'
        call mprnt(buff)
        write(buff,'(1x,a)')'Please check the rowtypes !'
        call mprnt(buff)
        stop
      endif
      w1=w1-wignore
      if(w1.gt.0)then
        write(buff,'(1x,a,i8)')'Rowtype warnings ignored:',w1
        call mprnt(buff)
      endif
      write(buff,'(1x,a,a)')'Objective function   :',objname
      call mprnt(buff)
c
c check for duplicated rownames
c
C      ix=0
C      do i=2,m
C        call btoc(rownam(8*i-7),c1)
C        call btoc(rownam(8*(i-1)-7),c2)
C        if(c1.le.c2)then
C          print*,'WRONG ROWNAMES:  ',C1,'  INDEX:',index1(i-1)
C          print*,'                 ',C2,'  INDEX:',index1(i)
C          ix=1
C        endif
C      enddo
C      if(ix.ne.0)stop
c
c columns section
c
      oldname='        '
  30  call fread(fin,sense,name0,name1,val1,name2,val2,w8,wignore)
      if(sense.ne.'RHS')then
        if(oldname.ne.name0)then
          n=n+1
          if(n.gt.maxn)then
            write(buff,'(1x,a,i8)')'To many columns. Current maximum :',
     x      maxn
            call mprnt(buff)
            iok=2
            goto 935
          endif
          call ctob(colnam(n),colnam(n+maxn),name0,maxn,hsval)
          if(chdr(hsval).eq.0)ni=ni+1
          index2(n)=chdr(hsval)
          chdr(hsval)=n
          colpnt(n)=pnt
          oldname=name0
          if(n.gt.1)then
            do 32 i=colpnt(n-1),pnt-1
              colind(rowidx(i))=0
  32        continue
          endif
        endif
        if((name1.ne.'        ').and.(abs(val1).gt.tzer))then
          if(name1.eq.objname)then
            if(abs(obj(n)).gt.tzer)then
              w3=w3+1
              if(w3.le.wignore)then
                write(buff,'(1x,a,a,a,a)')'WARNING : row ',name1,
     x          ' is duplicated in column ',name0
                call mprnt(buff)
              endif
            else
              obj(n)=val1*dble(minmax)
            endif
          else
            call fndnam(rhdr,index1,name1,rownam,maxm,ix)
            if(ix.gt.0)then
              if(pnt.gt.maxnz)then
                write(buff,'(1x,a,i8)')
     x          'To many nonzeros. Current maximum :',maxnz
                call mprnt(buff)
                iok=3
                goto 935
              endif
              if(colind(ix).ne.0)then
                w2=w2+1
                if(w2.le.wignore)then
                  write(buff,'(1x,a,a,a,a)')'WARNING : row ',name1,
     x            ' is duplicated in column ',name0
                  call mprnt(buff)
                endif
              else
                nonzeros(pnt)=val1
                rowidx(pnt)=ix
                colind(ix)=1
                pnt=pnt+1
              endif
            else
              w2=w2+1
              if(w2.le.wignore)then
                write(buff,'(1x,a,a,a)')
     x          'WARNING : wrong rowname : ',NAME1,' ignored'
                call mprnt(buff)
              endif
            endif
          endif
        endif
        if((name2.ne.'        ').and.(abs(val2).gt.tzer))then
          if(name2.eq.objname)then
            if(abs(obj(n)).gt.tzer)then
              w3=w3+1
              if(w3.le.wignore)then
                write(buff,'(1x,a,a,a,a)')'WARNING : row ',name2,
     x          ' is duplicated in column ',name0
                call mprnt(buff)
              endif
            else
              obj(n)=val2*dble(minmax)
            endif
          else
            call fndnam(rhdr,index1,name2,rownam,maxm,ix)
            if(ix.gt.0)then
              if(pnt.gt.maxnz)then
                write(buff,'(1x,a,i8)')
     x          'To many nonzeros. Current maximum :',maxnz
                call mprnt(buff)
                iok=3
                goto 935
              endif
              if(colind(ix).ne.0)then
                w3=w3+1
                if(w3.le.wignore)then
                  write(buff,'(1x,a,a,a,a)')'WARNING : row ',name2,
     x            ' is duplicated in column ',name0
                  call mprnt(buff)
                 endif
              else
                nonzeros(pnt)=val2
                rowidx(pnt)=ix
                colind(ix)=1
                pnt=pnt+1
              endif
            else
              w2=w2+1
              if(w2.le.wignore)then
                write(buff,'(1x,a,a,a)')'WARNING : wrong rowname : ',
     x          name2,' ignored'
                call mprnt(buff)
              endif
            endif
          endif
        endif
        goto 30
      endif
      colpnt(n+1)=pnt
      w2=w2-wignore
      if(w2.gt.0)then
        write(buff,'(1x,a,i8)')'Rowname warnings ignored:',w2
        call mprnt(buff)
      endif
      w3=w3-wignore
      if(w3.gt.0)then
        write(buff,'(1x,a,i8)')'Duplicat row warnings ignored:',w3
        call mprnt(buff)
      endif
c
c check for duplicated colnames
c
C      ix=0
C      do 33 i=2,n
C        call btoc(colnam(8*i-7),c1)
C        call btoc(colnam(8*(i-1)-7),c2)
C        if(c1.le.c2)then
C          print*,'WRONG COLNAMES: ',C1,'  INDEX:',index2(i-1)
C          print*,'                ',C2,'  INDEX:',index2(i)
C          ix=1
C        endif
C  33  continue
C      if(ix.ne.0)stop
c
c default values for rhs, range, lo-hi bounds
c
      do 35 i=1,m
        if(rowtyp(i).eq.1)then
          range(i)=0.0d+0
        else
          range(i)=big
        endif
        rhs(i)=0.0d+0
  35  continue
      do 40 i=1,n
        lbound(i)=0
        ubound(i)=big
  40  continue
c
c rhs section
c
      write(buff,5)ni,mi
      call mprnt(buff)
      if(rhsname.eq.'        ')then
        in=-1
      else
        in=0
      endif
  45  call fread(fin,sense,name0,name1,val1,name2,val2,w8,wignore)
      if((sense.ne.'RAN').AND.(SENSE.NE.'BOU').AND.(SENSE.NE.'END'))then
        if(in.lt.0)then
          rhsname=name0
          in=0
        endif
        if(rhsname.eq.name0)then
          if(name1.ne.'        ')then
            if(name1.eq.objname)then
              addobj=val1
            else
              call fndnam(rhdr,index1,name1,rownam,maxm,ix)
              if(ix.gt.0)then
                in=in+1
                rhs(ix)=val1
              else
                w4=w4+1
                if(w4.le.wignore)then
                  write(buff,'(1x,a,a,a)')
     x           'WARNING : wrong rowname in the RHS: ',name1,' ignored'
                  call mprnt(buff)
                endif
              endif
            endif
          endif
          if(name2.ne.'        ')then
            if(name2.eq.objname)then
              addobj=val2
            else
              call fndnam(rhdr,index1,name2,rownam,maxm,ix)
              if(ix.gt.0)then
                in=in+1
                rhs(ix)=val2
              else
                w4=w4+1
                if(w4.le.wignore)then
                  write(buff,'(1x,a,a,a)')
     x            'WARNING : wrong rowname in the RHS:',name2,' ignored'
                  call mprnt(buff)
                endif
              endif
            endif
          endif
        endif
        goto 45
      endif
      w4=w4-wignore
      if(w4.gt.0)then
        write(buff,'(1x,a,i8)')'Rowname warnings ignored:',w4
        call mprnt(buff)
      endif
      if(in.le.0)then
        write(buff,'(1x,a)')'WARNING : no rhs  value found'
        call mprnt(buff)
      else
        write(buff,9)rhsname,in
        call mprnt(buff)
      endif
c
c ranges
c
      if(sense.eq.'RAN')then
        if(ranname.eq.'        ')then
          in=-1
        else
          in=0
        endif
  50    call fread(fin,sense,name0,name1,val1,name2,val2,w8,wignore)
        if((sense.ne.'BOU').AND.(SENSE.NE.'END'))then
          if(in.lt.0)then
            ranname=name0
            in=0
          endif
          if(ranname.eq.name0)then
            if(name1.ne.'        ')then
              call fndnam(rhdr,index1,name1,rownam,maxm,ix)
              if(ix.gt.0)then
                if(abs(val1).ge.bigbou)then
                  w9=w9+1
                  if(w9.le.wignore)then
                    write(buff,'(1x,a,d12.6,a)')
     x              'WARNING :  Range  ',val1,' exceed BIGBOUND'
                    call mprnt(buff)
                  endif
                  val1=big
                endif
                in=in+1
                range(ix)=val1
              else
              w5=w5+1
              if(w5.le.wignore)then
                 write(buff,'(1x,a,a,a)')
     x           'WARNING : wrong rowname in the RANGES :',name1,
     x           ' ignored'
                 call mprnt(buff)
               endif
              endif
            endif
            if(name2.ne.'        ')then
              call fndnam(rhdr,index1,name2,rownam,maxm,ix)
              if(ix.gt.0)then
                if(abs(val2).ge.bigbou)then
                  w9=w9+1
                  if(w9.le.wignore)then
                    write(buff,'(1x,a,d12.6,a)')
     x              'WARNING :  Range  ',val1,' exceed BIGBOUND'
                    call mprnt(buff)
                  endif
                  val2=big
                endif
                in=in+1
                range(ix)=val2
              else
                write(buff,'(1x,a,a,a)')
     x          'Wrong rowname in the RANGES :',NAME2,' ignored'
                call mprnt(buff)
              endif
            endif
          endif
          goto 50
        endif
        w5=w5-wignore
        if(w5.gt.0)then
          write(buff,'(1x,a,i8)')'Rowname warnings ignored:',w5
          call mprnt(buff)
        endif
        if(in.le.0)then
          write(buff,'(1x,a)')'WARNING : no RANGE value found'
          call mprnt(buff)
        else
          write(buff,10)ranname,in
          call mprnt(buff)
        endif
      endif
c
c bounds
c
      if(sense.eq.'BOU')then
        if(bouname.eq.'        ')then
          in=-1
        else
          in=0
        endif
  55    call fread(fin,sense,name0,name1,val1,name2,val2,w8,wignore)
        if(sense.ne.'END')then
          if(in.lt.0)then
            bouname=name0
            in=0
          endif
          if(bouname.eq.name0)then
            call fndnam(chdr,index2,name1,colnam,maxn,ix)
            if(ix.gt.0)then
              if(sense.eq.' BV')then
                w9=w9+1
                if(w9.le.wignore)then
                  write(buff,'(1x,a)')
     x            'WARNING :  BV  replaced with  UP'
                  call mprnt(buff)
                endif
                sense=' UP'
              endif
              if(sense.eq.' LO')then
                if(val1.le.-bigbou)then
                  w9=w9+1
                  if(w9.le.wignore)then
                    write(buff,'(1x,a,d12.6,a)')
     x              'WARNING :  Lower bound ',val1,' exceed BIGBOUND'
                    call mprnt(buff)
                  endif
                  val1=-big
                endif
                lbound(ix)=val1
                in=in+1
              else if(sense.eq.' UP')then
                if(val1.ge.bigbou)then
                  w6=w6+1
                  if(w6.le.wignore)then
                    write(buff,'(1x,a,d12.6,a)')
     x               'WARNING :  Upper bound ',val1,' exceed BIGBOUND'
                    call mprnt(buff)
                  endif
                  val1=big
                endif
                ubound(ix)=val1
                in=in+1
              else if(sense.eq.' FX')then
                lbound(ix)=val1
                ubound(ix)=val1
                in=in+1
              else if(sense.eq.' MI')then
                lbound(ix)=-big
                ubound(ix)=0
                in=in+1
              else if(sense.eq.' FR')then
                freen=freen+1
                ubound(ix)=big
                lbound(ix)=-big
                in=in+1
              else if(sense.eq.' PL')then
                ubound(ix)=big
                in=in+1
              else
                w6=w6+1
                if(w6.le.wignore)then
                  write(buff,'(1x,a,a,a)')
     x            'WARNING : wrong boundtype :',sense,' ignored'
                  call mprnt(buff)
                endif
              endif
            else
             w7=w7+1
             if(w7.le.wignore)then
               write(buff,'(1x,a,a,a)')
     x         'WARNING : wrong colname in the BOUNS:',name1,' ignored'
               call mprnt(buff)
             endif
            endif
          endif
          goto 55
        endif
        w6=w6-wignore
        if(w6.gt.0)then
          write(buff,'(1x,a,i8)')'Bound type warnings ignored:',w6
          call mprnt(buff)
        endif
        w7=w7-wignore
        if(w7.gt.0)then
          write(buff,'(1x,a,i8)')'Column name warnings ignored:',w7
          call mprnt(buff)
        endif
        w9=w9-wignore
        if(w9.gt.0)then
          write(buff,'(1x,a,i8)')'Bound limit warnings ignored:',w9
          call mprnt(buff)
        endif
        if(in.le.0)then
          write(buff,'(1x,a)')'WARNING : no bound value found'
          call mprnt(buff)
        else
          write(buff,11)bouname,in
          call mprnt(buff)
        endif
      endif
      w8=w8-wignore
      if(w8.gt.0)then
        write(buff,'(1x,a,i8)')'Numeric format warnings ignored:',w8
        call mprnt(buff)
      endif
c
c check for range=0 and rhs > bigbound
c
      do 105 i=1,m
        if((rowtyp(i).gt.1).and.(abs(range(i)).le.tzer))rowtyp(i)=1
        if((rowtyp(i).gt.0).and.(rhs(i).ge.bigbou))then
          w0=w0+1
          if(w0.le.wignore)then
            call btoc(rownam(i),rownam(i+maxm),name0)
            write(buff,'(1x,a,d12.6,a,a)')
     x      'WARNING : Too big RHS value :',rhs(i),' row ignored:',name0
            call mprnt(buff)
          endif
          rowtyp(i)=0
        endif
 105  continue
      w0=w0-wignore
      if(w0.gt.0)then
        write(buff,'(1x,a,i8)')'RHS limit warnings ignored:',w0
        call mprnt(buff)
      endif
c
c check for bounds consistance, select the longest column
c
      lcol=-1
      ix=0
      do 106 i=1,n
        if(colpnt(i+1)-colpnt(i).gt.lcol)then
          lcol=colpnt(i+1)-colpnt(i)
          icol=i
        endif
        if(ubound(i).lt.lbound(i))then
          call btoc(colnam(i),colnam(i+maxn),c1)
          write(buff,2)c1
          call mprnt(buff)
          ix=1
        endif
 106  continue
      if(ix.gt.0)then
        stop
      endif
c
c endata, introduce slack variables if requested
c
      nn=n
      if (inslck.gt.0)then
        do i=1,m
          if(rowtyp(i).gt.1)then
            if(n.ge.maxn)then
              write(buff,'(1x,a,i8)')
     x        'To many columns. Current maximum :',maxn
              call mprnt(buff)
              n=n+m-i+1
              iok=2
              goto 999
            endif
            n=n+1
            if(colpnt(n).ge.maxnz)then
              write(buff,'(1x,a,i8)')
     x        'To many nonzeros. Current maximum :',maxnz
              call mprnt(buff)
              iok=3
              n=n+m-i+1
              goto 999
            endif
            colpnt(n+1)=colpnt(n)+1
            rowidx(colpnt(n))=i
            if(rowtyp(i).eq.2)then
              nonzeros(colpnt(n))=-1.0d+00
            else
              nonzeros(colpnt(n))=+1.0d+00
            endif
            lbound(n)=0.0d+00
            obj(n)=0.0d+00
            ubound(n)=range(i)
            range(i)=0.0d+00
            rowtyp(i)=1
          endif
        enddo
      endif
      nz=colpnt(n+1)-1
c
c  Write statistics
c
      call btoc(colnam(icol),colnam(icol+maxn),c1)
      write(buff,'(1X)')
      call mprnt(buff)
      write(buff,12)'Number of rows       :',m
      call mprnt(buff)
      write(buff,12)'Number of columns    :',n
      call mprnt(buff)
      write(buff,12)'Free variables       :',freen
      call mprnt(buff)
      write(buff,12)'Number of nonzeros   :',nz
      call mprnt(buff)
      write(buff,13)'Length of long. col. :',lcol,c1
      call mprnt(buff)
      write(buff,'(1X)')
      call mprnt(buff)
c
c Row and column names are written to a scratch file
c
      open(sfile,status='SCRATCH',FORM='UNFORMATTED',err=955)
      write(sfile)(rownam(i),i=1,m)
      write(sfile)(rownam(i+maxm),i=1,m)
      write(sfile)(colnam(i),i=1,nn)
      write(sfile)(colnam(i+maxn),i=1,nn)
      goto 999
c
c Check the number of the rows
c
 925  read(fin,'(a4,a8)',err=945)sen4,name0
      if(sen4.ne.'COLU')then
        m=m+1
        goto 925
      endif
      name0='        '
c
c Check the number of the columns
c
 935  read(fin,'(a4,a8)',err=945)sen4,name1
      if(sen4.ne.'    ')then
        if(inslck.gt.0)n=n+m
        goto 999
      endif
      if(name0.ne.name1)then
        n=n+1
        name0=name1
      endif
      goto 935
c
c File error
c
 955  write(buff,'(1x,a)')'File creation error. Execution halted.'
      call mprnt(buff)
      stop
c
c Wrong MPS file
c
 945  write(buff,'(1x,a)')'ERROR IN READING THE MPS FILE.'
      call mprnt(buff)
      write(buff,'(1x,a,a)')'CHECK THE EXISTENCE OF THE RECORDS :',
     x 'NAME, ROWS, COLUMNS, RHS, ENDATA'
      call mprnt(buff)
      stop
 999  close(fin)
      return
      end
c
c ===========================================================================
c
      subroutine freadnam(
     x fin)
      integer*4 fin
c
      integer*4    star
      character*80 st
      character    sta(80)
      equivalence  (st,sta(1))
      character*99 buff
c
c ---------------------------------------------------------------------------
c
  10  read(fin,'(A80)')st
      star=1
  15  if(sta(star).eq.'*')goto 20
      star=star+1
      if(star.le.80)goto 15
  20  if(star.lt.5)goto 10
      if(st(1:4).ne.'NAME')then
        write(buff,'(1x,a)')'FATAL : NAME  RECORD NOT FOUND'
        call mprnt(buff)
        stop
      endif
      write(buff,'(1x,a,a)')'Name :',st(8:(star-1))
      call mprnt(buff)
      return
      end
c
c ===========================================================================
c
      subroutine fread(
     x fin,sense,name0,name1,val1,name2,val2,w8,wignore)
c
      character*8 name0,name1,name2
      character*3 sense
      real*8      val1,val2
      integer*4   fin,w8,wignore
c
      integer*4    star
      character*64 st,blk
      character    sta(80)
      equivalence  (st,sta(1))
      character*99 buff
c
c --------------------------------------------------------------------------
c
      blk=
     x'                                                                '
  10  star=1
      st=blk
      read(fin,'(A64)',err=5)st
      goto 15
   5  write(buff,'(1x,a)')'ERROR IN READING THE MPS FILE.'
      call mprnt(buff)
      write(buff,'(1x,a,a)')'CHECK THE EXISTENCE OF THE RECORDS :',
     x 'NAME, ROWS, COLUMNS, RHS, ENDATA'
      call mprnt(buff)
      stop
  15  if(sta(star).eq.'*')goto 20
      star=star+1
      if(star.eq. 6)star=13
      if(star.eq.16)star=23
      if(star.eq.41)star=48
      if(star.le.64)goto 15
  20  if((star.lt.4).or.(st(1:(star-1)).eq.blk(1:(star-1))))goto 10
      sense(1:3)=st(1:3)
      if(star.lt.6)then
         name0='        '
         name1='        '
         name2='        '
         val1=0.0d+0
         val2=0.0d+0
         goto 99
      endif
      name0(1:8)=st(5:12)
      if(star.lt.16)then
         name1='        '
         name2='        '
         val1=0.0d+0
         val2=0.0d+0
         goto 99
      endif
      name1(1:8)=st(15:22)
      if(star.lt.37)then
         name2='        '
         val1=0.0d+0
         val2=0.0d+0
         goto 99
      endif
      read(st(25:36),'(E12.0)',err=30)val1
      goto 25
  30  w8=w8+1
      if(w8.le.wignore)then
        write(buff,'(1x,a,a)')
     x  'WARNING : invalid numeric format :',st(25:36)
        call mprnt(buff)
      endif
      val1=0.0d+0
  25  if(star.lt.41)then
         name2='        '
         val2=0.0d+0
         goto 99
      endif
      name2(1:8)=st(40:47)
      if(star.lt.62)then
         val2=0.0d+0
         goto 99
      endif
      read(st(50:61),'(E12.0)',err=40)val2
      goto 35
  40  w8=w8+1
      if(w8.le.wignore)then
        write(buff,'(1x,a,a)')
     x  'WARNING : invalid numeric format :',st(50:61)
        call mprnt(buff)
      endif
      val2=0.0d+0
  35  continue
  99  return
      end
c
c ===========================================================================
c
      subroutine fndnam(hdr,index,name,names,n,ix)
      integer*4 n,hdr(n),index(n),names(2*n),ix,a,b
      character*8 name
      call ctob(a,b,name,n,ix)
      ix=hdr(ix)
  10  if(ix.ne.0)then
        if((names(ix).eq.a).and.(names(n+ix).eq.b))goto 99
        ix=index(ix)
        goto 10
      endif
  99  return
      end
c
c ===========================================================================
c
      subroutine btoc(a,b,c)
      integer*4 a,b
      character*8 c
      integer*4  xx(2)
      character*8 xy
      equivalence (xx,xy)
      xx(1)=a
      xx(2)=b
      c=xy
      return
      end
c
c ============================================================================
c
      subroutine ctob(a,b,c,hbl,hsval)
      integer*4 a,b
      integer*4   hbl,hsval
      character*8 c
      integer*4  xx(2)
      character*8 xy
      equivalence (xx,xy)
      xy=c
      a=xx(1)
      b=xx(2)
      hsval=mod(abs(262144*ichar(c(1:1))+4096*ichar(c(2:2))+
     x 64*ichar(c(3:3))+ichar(c(4:4))+
     x 262144*ichar(c(5:5))+4096*ichar(c(6:6))+64*ichar(c(7:7))+
     x ichar(c(8:8))),hbl)+1
      return
      end
c
c ============================================================================
